/*
* MORFEO Project
* http://www.morfeo-project.org
*
* Component: TIDorbJ
* Programming Language: Java
*
* File: $Source$
* Version: $Revision: 2 $
* Date: $Date: 2005-12-19 08:58:21 +0100 (Po, 19 pro 2005) $
* Last modified by: $Author: caceres $
*
* (C) Copyright 2004 Telefnica Investigacin y Desarrollo
*     S.A.Unipersonal (Telefnica I+D)
*
* Info about members and contributors of the MORFEO project
* is available at:
*
*   http://www.morfeo-project.org/TIDorbJ/CREDITS
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*
* If you want to use this software an plan to distribute a
* proprietary application in any way, and you are not licensing and
* distributing your source code under GPL, you probably need to
* purchase a commercial license of the product.  More info about
* licensing options is available at:
*
*   http://www.morfeo-project.org/TIDorbJ/Licensing
*/    
package es.tid.TIDorbj.core.poa.policies;

import org.omg.CORBA.Any;
import org.omg.CORBA.BAD_PARAM;
import org.omg.CORBA.BAD_POLICY_VALUE;
import org.omg.CORBA.PolicyError;
import org.omg.PortableServer.RequestProcessingPolicyValue;
import org.omg.PortableServer.RequestProcessingPolicyValueHelper;

/**
 * Implementation of RequestProcessingPolicy
 * 
 * @autor Javier Fdz. Mejuto
 * @version 1.0
 */

public class RequestProcessingPolicyImpl 
extends org.omg.PortableServer.RequestProcessingPolicyLocalBase
{

    private RequestProcessingPolicyValue m_value;

    public RequestProcessingPolicyImpl(RequestProcessingPolicyValue value)
    {
        m_value = value;
    }

    public org.omg.PortableServer.RequestProcessingPolicyValue value()
    {
        return m_value;
    }

    public int policy_type()
    {
        return org.omg.PortableServer.REQUEST_PROCESSING_POLICY_ID.value;
    }

    public org.omg.CORBA.Policy copy()
    {
        return new RequestProcessingPolicyImpl(m_value);
    }

    public void destroy()
    {
    // do nothing!
    }
    
    public static RequestProcessingPolicyImpl createPolicy(Any val)
    throws org.omg.CORBA.PolicyError
{
    try {
        RequestProcessingPolicyValue value = 
            RequestProcessingPolicyValueHelper.extract(val);
        return new RequestProcessingPolicyImpl(value);
    }
    catch (BAD_PARAM bp) {
        throw new PolicyError(BAD_POLICY_VALUE.value);
    }
}

}