/*
* MORFEO Project
* http://www.morfeo-project.org
*
* Component: TIDorbJ
* Programming Language: Java
*
* File: $Source$
* Version: $Revision: 113 $
* Date: $Date: 2007-11-12 09:05:20 +0100 (Po, 12 lis 2007) $
* Last modified by: $Author: avega $
*
* (C) Copyright 2004 Telefnica Investigacin y Desarrollo
*     S.A.Unipersonal (Telefnica I+D)
*
* Info about members and contributors of the MORFEO project
* is available at:
*
*   http://www.morfeo-project.org/TIDorbJ/CREDITS
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*
* If you want to use this software an plan to distribute a
* proprietary application in any way, and you are not licensing and
* distributing your source code under GPL, you probably need to
* purchase a commercial license of the product.  More info about
* licensing options is available at:
*
*   http://www.morfeo-project.org/TIDorbJ/Licensing
*/    
package es.tid.TIDorbj.tools;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

import es.tid.TIDorbj.core.iop.DefaultIOR;
import es.tid.TIDorbj.core.iop.IOR;

public class PrintIOR
{

    public static void main(String[] argv)
    {

        if ((argv == null) || (argv.length != 1)) {

            System.out.println("Usage: printIOR [ior|file]");
            return;
        }

        String ior_str = null;

        try { // try to read in a file
            FileReader file = new FileReader(argv[0]);
            BufferedReader reader = new BufferedReader(file);

            ior_str = reader.readLine();
            file.close();
        }
        catch (java.io.FileNotFoundException ioe) {
            // Argument is the IOR, not a file
        }
        catch (IOException ioe) {
            ioe.printStackTrace();
            return;
        }

        try {
            IOR ior = null;
            if (ior_str == null)
                ior = DefaultIOR.fromString(null, argv[0]);
            else
                ior = DefaultIOR.fromString(null, ior_str);

            int size = ior.memberCount();

            if (size == 0) {
                System.out.println("IOR: nil");
            } else {
                System.out.println("IOR:");

                System.out.println("Repository Id: " + ior.getTypeId());

                System.out.println("(" + size + " Profiles)");

                for (int i = 0; i < size; i++)
                    System.out.println(ior.getProfile(i).toString());
            }

            System.out.flush();
        }
        catch (Throwable th) {
            System.out.println("Invalid IOR");
        }
    }
}
