import java.util.Properties;
import java.io.*;

import Echo.TestHelper;
import Echo.Test;


class ClientThread extends Thread {
    private int m_id;
    private int m_events;
    private Test m_refTest;

    public ClientThread(int id, int events, Test refTest){
        this.m_id = id;
        this.m_events = events;
        this.m_refTest = refTest;
    }

    public void run(){

        String message = "Hola mundo";
        
        long currentTime = System.currentTimeMillis();

        for (int i=0; i < m_events; i++) {
    
            try {    

                String response = this.m_refTest.echo(message);
                /*
                  System.out.println("[ClientThread" + this.m_id + " ] echo(" + 
                                     message + ") = " + response);
                */

            } catch (org.omg.CORBA.NO_RESPONSE e) {
                System.err.println("[ClientThread " + this.m_id + "] " + 
                                   "CORBA NO_RESPONSE exception received");
            } catch (Exception e) {                                     
                System.err.println("[ClientThread " + this.m_id + "] Excepcion: " + 
                                   e.getMessage());
                e.printStackTrace();
            }  
            
        } // for

        currentTime = System.currentTimeMillis() - currentTime;
	System.out.println(" ClientThread: " + this + " Time : " + currentTime + " +");
    }

}
