import java.util.Properties;
import java.io.*;

import Echo.TestHelper;
import Echo.Test;



public class EchoClient {
    public static void main(String args[])
    {
    	try {
            // Create and initialize orb
            /*
            Properties props = new Properties();
            props.setProperty("org.omg.CORBA.ORBClass", 
                              "es.tid.TIDorbj.core.TIDORB");
            props.setProperty("org.omg.CORBA.ORBSingletonClass", 
                              "es.tid.TIDorbj.core.SingletonORB");
            props.setProperty("es.tid.TIDorbj.trace.level", "4");
            props.setProperty("es.tid.TIDorbj.trace.file", "client.log");
            props.setProperty("es.tid.TIDorbj.max_blocked_time", "1500000");
            props.setProperty("es.tid.TIDorbj.bidirectional", "BOTH");
            */
            org.omg.CORBA_2_3.ORB orb = 
                (org.omg.CORBA_2_3.ORB) org.omg.CORBA.ORB.init(args,System.getProperties());

            // Get ior
            String ior_str = null;
            String dbior = "Test.ior";
            File ior_fl = new File(dbior);
        
            if (ior_fl.exists()) { //ior in file
                try {
                    BufferedReader br = new BufferedReader(new FileReader(ior_fl));
                    ior_str = br.readLine();
                    br.close();
                } catch (java.io.IOException e) {
                    System.err.println("Error reading file " + dbior);
                    System.exit(1);
                }
            }
            else { //ior in standard input
                try {
                    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
                    ior_str = br.readLine();
                    br.close();
                } catch (java.io.IOException e) {
                    System.err.println("Error standard input");
                    System.exit(1);
                }
            }	

            // Get object reference
            org.omg.CORBA.Object obj = orb.string_to_object(ior_str);
            Test refTest = TestHelper.narrow(obj);



            // Start multiple client threads
	    // ZL - SET NUMBER OF THREADS
            int num_threads;
	    try{
	      num_threads = Integer.parseInt(System.getProperty("numThreads"));
	    } catch (Exception e){
	      num_threads = 10;
	    }

	    // ZL - SET NUMBER OF ITERATIONS IN EACH THREADS
            int num_iterations;
	    try{
	      num_iterations = Integer.parseInt(System.getProperty("numIterations"));
	    } catch (Exception e){
	      num_iterations = 10;
	    }

	    System.out.println(" ((( ZL ))) - numThreads:"+num_threads+ " numIterations:"+num_iterations);

            ClientThread clients[] = new ClientThread[num_threads];

            System.out.println("[Client] Creating ClientThreads ...");
            for (int i = 0; i < num_threads; i++) {
                clients[i] = new ClientThread(i, num_iterations, refTest);
            }
            
            System.out.println("[Client] Starting ClientThreads ...");
            for (int i = 0; i < num_threads; i++) {
                clients[i].start();
            }
            
            System.out.println("[Client] Join to ClientThreads ...");
            for (int i = 0; i < num_threads; i++) {
                clients[i].join();
            }
            //clients[19].join();

            System.out.println("[Client] Sending shutdown to server");
            refTest.shutdown();

            System.out.println("[Client] Destroying ORB ...");
            //orb.destroy();
            
            //System.exit(0);
    	}
    	catch (Exception e) {
            System.err.println("Main: Unexpected exception " + e.getMessage());
            e.printStackTrace();
            System.exit(1);
        }
    }
}
