/*
 * MORFEO Project
 * http://www.morfeo-project.org
 *
 * Component: TIDorbJTest
 * Programming Language: Java
 *
 * File: $Source: EchoClient.java $
 * Version: $Revision: 1.0 $
 * Date: $Date: 10-ago-2006 $
 * Last modified by: $Author: irenka.redondo $
 *
 * (C) Copyright 2004 Telefnica Investigacin y Desarrollo
 *     S.A.Unipersonal (Telefnica I+D)
 *
 * Info about members and contributors of the MORFEO project
 * is available at:
 *
 *   http://www.morfeo-project.org/TIDorbJ/CREDITS
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * If you want to use this software an plan to distribute a
 * proprietary application in any way, and you are not licensing and
 * distributing your source code under GPL, you probably need to
 * purchase a commercial license of the product.  More info about
 * licensing options is available at:
 *
 *   http://www.morfeo-project.org/TIDorbJ/Licensing
 */

import java.util.Properties;
import java.io.*;

import Echo.TestHelper;
import Echo.Test;

import org.omg.CosNaming.*;
import org.omg.CORBA_2_3.ORB;

public class EchoClient {
    public static void main(String args[])
    {
    	try {
            // Create and initialize orb
            Properties props = new Properties();

            org.omg.CORBA_2_3.ORB orb = 
                (org.omg.CORBA_2_3.ORB) org.omg.CORBA.ORB.init(args,System.getProperties());

            //
            // Obtain reference to NameService
            //
            NamingContext naming_context = null;
            try{
                naming_context = 
                    NamingContextHelper.narrow(orb.resolve_initial_references("NameService"));
                System.out.println("[client] corbaloc resolved");
            } catch(Exception e) {
                System.err.println("Main: Unexpected exception at resolve_initial_references" + 
                                   e.getMessage());
                e.printStackTrace();
                System.exit(1);
            }



            org.omg.CosNaming.NameComponent[] name = new org.omg.CosNaming.NameComponent[1];
            name[0] = new org.omg.CosNaming.NameComponent("MyEchoTest", "1");

            org.omg.CORBA.Object obj = null;
            // Resolv reference Test in NameService
            try{
                obj = naming_context.resolve(name);
            } catch(org.omg.CosNaming.NamingContextPackage.NotFound ex) {
                System.err.println("Main: CosNaming.NotFound excepcion " + ex.getMessage());
            } catch(org.omg.CosNaming.NamingContextPackage.CannotProceed ex) {
                System.err.println("Main: CosNaming.CannotProceed " + ex.getMessage());
            } catch(org.omg.CosNaming.NamingContextPackage.InvalidName ex) {
                System.err.println("Main: CosNaming.InvalidName " + ex.getMessage());
            } catch(org.omg.CORBA.SystemException ex) {
            }


            // Get object reference

            Test refTest = null;
            try{
                refTest = TestHelper.narrow(obj);

            } catch(Exception e) {
                System.err.println("Main: Unexpected exception at resolve_initial_references" + 
                                   e.getMessage());
                e.printStackTrace();
                System.exit(1);
            }



            String message = "Hola mundo";
            String response = refTest.echo(message);

            System.out.println("[Client] echo(" + message + ") = " + response);
            
            System.out.println("[Client] Destroying ORB ...");
            orb.destroy();
            
            //System.exit(0);
    	}
    	catch (Exception e) {
            System.err.println("Main: Unexpected exception " + e.getMessage());
            e.printStackTrace();
            System.exit(1);
        }
    }
}
