/*
 * MORFEO Project
 * http://www.morfeo-project.org
 *
 * Component: TIDorbJTest
 * Programming Language: Java
 *
 * File: $Source: EchoServer.java $
 * Version: $Revision: 1.0 $
 * Date: $Date: 10-ago-2006 $
 * Last modified by: $Author: irenka.redondo $
 *
 * (C) Copyright 2004 Telefnica Investigacin y Desarrollo
 *     S.A.Unipersonal (Telefnica I+D)
 *
 * Info about members and contributors of the MORFEO project
 * is available at:
 *
 *   http://www.morfeo-project.org/TIDorbJ/CREDITS
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * If you want to use this software an plan to distribute a
 * proprietary application in any way, and you are not licensing and
 * distributing your source code under GPL, you probably need to
 * purchase a commercial license of the product.  More info about
 * licensing options is available at:
 *
 *   http://www.morfeo-project.org/TIDorbJ/Licensing
 */

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.Properties;

//import org.omg.CORBA.ORB;
import org.omg.CORBA_2_3.ORB;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAHelper;

import org.omg.CosNaming.*;



public class EchoServer {
    public static void main(String[] args) {
        try {
            // Create and initialize orb
            Properties props = new Properties();

            org.omg.CORBA_2_3.ORB orb = 
                (org.omg.CORBA_2_3.ORB) org.omg.CORBA.ORB.init(args,System.getProperties());


     
//             //
//             // Obtain reference to NameService from corbaloc
//             //

//             String corbaloc = new String("corbaloc:iiop:1.2@dacha.hi.inet:48968/NameService");

//             System.out.println("[Server] corbaloc solving....");
//             NamingContext naming_context = null;
//             org.omg.CORBA.Object corbaloc_obj = null;

//             corbaloc_obj = orb.string_to_object(corbaloc);
//             //System.exit(1);

//             try {
//                 System.out.println("[Server] corbaloc resolving...");
//                 naming_context = 
//                     NamingContextHelper.narrow(corbaloc_obj);
//                 System.out.println("[Server] corbaloc resolved");
//             } catch (org.omg.CORBA.SystemException e) {
//                 System.err.println("Main: Unexpected exception at narrow" + e.getMessage());
//                 e.printStackTrace();
//                 System.exit(1);
//             }



            //
            // Get rootPOA reference and activate POAManager
            //

            POA rootPOA = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));
            rootPOA.the_POAManager().activate();




            // 
            // Create and activate the servant
            //

            MyEchoTestImpl servant = new MyEchoTestImpl();
			
            // Activate servant
            byte[] servantId = rootPOA.activate_object(servant);

            // Get servant reference and write it to file
            org.omg.CORBA.Object obj = rootPOA.id_to_reference(servantId);



            //
            // Create a NameComponent MyEchoTest
            // 

            System.out.println("[Server] OK.");

            org.omg.CosNaming.NameComponent[] name = new org.omg.CosNaming.NameComponent[1];
            name[0] = new org.omg.CosNaming.NameComponent("MyEchoTest", "");





            //
            // Obtain reference to NameService from initial references
            //

            NamingContext naming_context = null;
            org.omg.CORBA.Object naming_context_obj = null;


            try{
                System.out.println("[Server] resolve initial references...");

                // Way 1
                naming_context_obj = 
                    orb.resolve_initial_references("NameService");

//                 // Way 2
//                 String corbaname = new String("corbaname:rir:/NameService");
//                 naming_context_object = orb.string_to_object(corbaname);


                System.out.println("[Server] resolved");
            } catch(Exception e) {
                System.err.println("Main: Unexpected exception at resolve_initial_references" + 
                                   e.getMessage());
                e.printStackTrace();
                System.exit(1);
            }



            try{
                System.out.println("[Server] naming_context narrowing...");
                naming_context = 
                    NamingContextHelper.narrow(naming_context_obj);
                System.out.println("[Server] naming_context narrowed");
            } catch(Exception e) {
                System.err.println("Main: Unexpected exception at resolve_initial_references" + 
                                   e.getMessage());
                e.printStackTrace();
                System.exit(1);
            }



            //
            // Bind reference Test in NameService
            //

            System.out.println("[Server] rebinding....");
            try {
                naming_context.rebind(name, obj);
                System.out.println("[Server] rebinded");
            } catch (Exception e) {
                System.err.println("Main: Unexpected exception at rebind" + e.getMessage());
                e.printStackTrace();
                System.exit(1);
            }

            // Start serving requests
            System.out.println("[Server] Running...");
            orb.run();
			
            //Destroy orb
            orb.destroy();
			
            System.exit(0);

        } catch (Exception e) {
            System.err.println("Main: Unexpected exception " + e.getMessage());
            e.printStackTrace();
            System.exit(1);
        }
    }
}
