import java.util.Properties;
import java.util.*;
import java.io.*;

import Test.*;
import org.omg.CORBA_2_3.ORB;
import org.omg.PortableServer.*;
import org.omg.CORBA.*;

public class Client {


  public static void main(String[] args) {
      try {
            // Create and initialize orb
            Properties props = new Properties();
            /*
            props.setProperty("org.omg.CORBA.ORBClass", 
                              "es.tid.TIDorbj.core.TIDORB");
            props.setProperty("org.omg.CORBA.ORBSingletonClass", 
                              "es.tid.TIDorbj.core.SingletonORB");
            props.setProperty("es.tid.TIDorbj.trace.level", "3");
            props.setProperty("es.tid.TIDorbj.trace.file", "client.log");

            org.omg.CORBA_2_3.ORB orb = (org.omg.CORBA_2_3.ORB) ORB.init(args, props);
            */

            org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,System.getProperties());

            // Get ior
            String ior_str = null;
            String dbior = "Tester.ior";
            File ior_fl = new File(dbior);
        
            if (ior_fl.exists()) { //ior in file
                try {
                    BufferedReader br = new BufferedReader(new FileReader(ior_fl));
                    ior_str = br.readLine();
                    br.close();
                } catch (java.io.IOException e) {
                    System.err.println("Error reading file " + dbior);
                    System.exit(1);
                }
            }
            else { //ior in standard input
                try {
                    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
                    ior_str = br.readLine();
                    br.close();
                } catch (java.io.IOException e) {
                    System.err.println("Error standard input");
                    System.exit(1);
                }
            }	



            
            // Get object reference
            org.omg.CORBA.Object obj = orb.string_to_object(ior_str);
            Controller ctrl = ControllerHelper.narrow(obj);


            for(int i = 1; i < 10; i++){
                try {    
                    Test.Thermometer thermometer =  ctrl.getThermometer(i);
                    System.out.println("[Client] Thermometer " + i);
                    System.out.println("[Client]    Model:  " + thermometer.model());
                    System.out.println("[Client]    Asset number: " + thermometer.asset_num());
                    System.out.println("[Client]    Temperature: " + thermometer.temperature());
                } catch (org.omg.CORBA.NO_RESPONSE e) {
                    System.err.println("[Client] " + 
                                       "CORBA NO_RESPONSE exception received");
                }
            }

            System.out.println("[Client] Exit");
            ctrl.shutdown();
            System.exit(0);

	}
    	catch (Exception e) {
            System.err.println("Main: Unexpected exception " + e.getMessage());
            e.printStackTrace();
            System.exit(1);
        }




  } // main method


} // class Client
