import Test.*;
import org.omg.PortableServer.*;
import org.omg.CORBA.*;


public class DefaultThermometerImpl extends ThermometerPOA {

    private String models[];
    private short  temperatures[];
       
    private org.omg.PortableServer.Current m_current;

    public DefaultThermometerImpl(org.omg.PortableServer.Current current,
                                  int anum) 
    {
        m_current = current;
        models = new String[anum];
        temperatures = new short[anum];

        for(int i = 0; i < anum; i++)
            temperatures[i] = (short) (i + 10);
        for(int i = 0; i < anum; i++)
            models[i] = "modelo";
    }

    public int get_thermometer() {
        // Se obtiene el ObjectId del destino
        byte[] oid = null;
        try { 
            oid = m_current.get_object_id();
        } catch(Exception e) {
            System.err.println("DefaultThermometerImpl get_object_id exception " + e.getMessage());
            throw new org.omg.CORBA.OBJECT_NOT_EXIST();
        }
        
        // Se comprueba si el ID del objeto es valido
        String cadena_oid;
        try{
            cadena_oid = new String(oid);
        } catch(Exception e) {
            System.err.println("DefaultThermometerImpl oid.toString() exception " + e.getMessage());
            throw new org.omg.CORBA.OBJECT_NOT_EXIST();
        }
        
        // Se convierte la cadena con el ID a un numero de elemento
        int element = 0;
        try {
            element = Integer.valueOf(cadena_oid).intValue();
        } catch(Exception e) {
            System.err.println("DefaultThermometerImpl cadena_oid.intValue() exception " + 
                               e.getMessage() + cadena_oid);
            throw new org.omg.CORBA.OBJECT_NOT_EXIST();
        }

 
        System.err.println("DefaultThermometerImpl element = " + element);
        return element;
    }

    public String model() {
        int thermometer = get_thermometer();
        return models[thermometer];
    } 

    public int asset_num() {
        int thermometer = get_thermometer();
        return thermometer;
    }

    public short temperature() {
        int thermometer = get_thermometer();
        return temperatures[thermometer];
    }


} // class DefaultThermometerImpl
