import Test.*;

import org.omg.PortableServer.ForwardRequest;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.Servant;
import org.omg.PortableServer.ServantLocatorOperations;
import org.omg.CORBA.*;

import java.lang.Byte;

public class ThermometerLocatorImpl implements ServantLocatorOperations {

    private int m_thermometers;

    public ThermometerLocatorImpl(int max) {
        m_thermometers = max;
    }

    public Servant preinvoke(byte[] oid, 
                             POA poa,
                             String operation,
                             org.omg.PortableServer.ServantLocatorPackage.CookieHolder cookie) 
        throws ForwardRequest 
    {
        System.out.println("[server] ThermometerLocator_impl::preinvoke() ");
        String cadena_oid;

        //
        // Check if Id of object is valid
        //
        try {
            cadena_oid = new String(oid);
        } catch (Exception e) {
            throw new org.omg.CORBA.OBJECT_NOT_EXIST();
        }

        //
        // Get element number from cadena_oid
        //
        int element = Integer.valueOf(cadena_oid).intValue();

        if (element > m_thermometers)
            throw new org.omg.CORBA.OBJECT_NOT_EXIST();
        

        //
        // Create thermomether
        //
        Servant servant = new ThermometerImpl(element);
        return servant;
    } // incarnate

    public void postinvoke(byte[] oid, 
                           POA poa, 
                           String operation, 
                           java.lang.Object cookie,
                           Servant servant)

    {
        System.out.println("[server] ThermometerLocator_impl::postinvoke() ");
        // TODO: delete servant
    } // etherealize
    

} // class ThermometerLocatorImpl
