#!/bin/sh
#
# MORFEO Project
# http://www.morfeo-project.org
#
# Component: TIDorbJ
# Programming Language: Java
#
# File: $Source: /cvsroot/tidorbj/TIDorbJTest/basic/echo/startServer.sh,v $
# Version: $Revision: 1.0 $
# Date: $Date: 2006/10/13 10:12:48 $
# Last modified by: $Author: avega $
#
# (C) Copyright 2004 Telefnica Investigacin y Desarrollo
#     S.A.Unipersonal (Telefnica I+D)
#
# Info about members and contributors of the MORFEO project
# is available at:
#
#   http://www.morfeo-project.org/TIDIdlc/CREDITS
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# If you want to use this software an plan to distribute a
# proprietary application in any way, and you are not licensing and
# distributing your source code under GPL, you probably need to
# purchase a commercial license of the product.  More info about
# licensing options is available at:
#
#   http://www.morfeo-project.org/TIDIdlc/Licensing
#

set +u

if [ -z "$JAVA_HOME" ]; then
    echo "Environment variable JAVA_HOME must be set"
    exit 1
fi

if [ -z "$TIDORBJ_HOME" ]; then
    echo "Environment variable TIDORBJ_HOME must be set"
    exit 1	
fi

JVM=$JDK_HOME/bin/java

#
# DefaultServant
#
echo "Starting DefaultServant test..."
#$JVM -XX:+HeapDumpOnOutOfMemoryError 
$JVM -classpath .:$CONTEST_HOME/Lib/ConTest.jar:$CONTEST_HOME/Lib/racedetector.jar:$CONTEST_HOME/Lib/deadlockcauser.jar:$TIDORBJ_HOME/lib/tidorbj_contest.jar \
    -Dorg.omg.CORBA.ORBClass=es.tid.TIDorbj.core.TIDORB \
    -Dorg.omg.CORBA.ORBSingletonClass=es.tid.TIDorbj.core.SingletonORB \
    server_DefaultServant \
    es.tid.TIDorbj.typecode_cache_size 1000 \
    es.tid.TIDorbj.iiop.max_connections 25 \
    es.tid.TIDorbj.max_blocked_time 5000000 \
    es.tid.TIDorbj.trace.file server_DefaultServant.log \
    es.tid.TIDorbj.trace.level 0 &
server_DefaultServant_pid=$!
sleep 10

$JVM -classpath .:$CONTEST_HOME/Lib/ConTest.jar:$CONTEST_HOME/Lib/racedetector.jar:$CONTEST_HOME/Lib/deadlockcauser.jar:$TIDORBJ_HOME/lib/tidorbj_contest.jar \
    -Dorg.omg.CORBA.ORBClass=es.tid.TIDorbj.core.TIDORB \
    -Dorg.omg.CORBA.ORBSingletonClass=es.tid.TIDorbj.core.SingletonORB \
    Client \
    es.tid.TIDorbj.max_blocked_time 5000000 \
    es.tid.TIDorbj.trace.file client_DefaultServant.log \
    es.tid.TIDorbj.trace.level 0 

sleep 2
kill $server_DefaultServant_pid



#
# ServantActivator
#
echo "Starting ServantActivator test..."
$JVM -classpath .:$CONTEST_HOME/Lib/ConTest.jar:$CONTEST_HOME/Lib/racedetector.jar:$CONTEST_HOME/Lib/deadlockcauser.jar:$TIDORBJ_HOME/lib/tidorbj_contest.jar \
    -Dorg.omg.CORBA.ORBClass=es.tid.TIDorbj.core.TIDORB \
    -Dorg.omg.CORBA.ORBSingletonClass=es.tid.TIDorbj.core.SingletonORB \
    server_ServantActivator \
    es.tid.TIDorbj.typecode_cache_size 1000 \
    es.tid.TIDorbj.iiop.max_connections 25 \
    es.tid.TIDorbj.max_blocked_time 5000000 \
    es.tid.TIDorbj.trace.file server_ServantActivator.log \
    es.tid.TIDorbj.trace.level 0 &
server_ServantActivator_pid=$!
sleep 10

$JVM -classpath .:$CONTEST_HOME/Lib/ConTest.jar:$CONTEST_HOME/Lib/racedetector.jar:$CONTEST_HOME/Lib/deadlockcauser.jar:$TIDORBJ_HOME/lib/tidorbj_contest.jar \
    -Dorg.omg.CORBA.ORBClass=es.tid.TIDorbj.core.TIDORB \
    -Dorg.omg.CORBA.ORBSingletonClass=es.tid.TIDorbj.core.SingletonORB \
    Client \
    es.tid.TIDorbj.max_blocked_time 5000000 \
    es.tid.TIDorbj.trace.file client_DefaultActivator.log \
    es.tid.TIDorbj.trace.level 0 
sleep 2
kill $server_ServantActivator_pid



#
# ServantLocator
#
echo "Starting ServantLocator test..."
$JVM -classpath .:$CONTEST_HOME/Lib/ConTest.jar:$CONTEST_HOME/Lib/racedetector.jar:$CONTEST_HOME/Lib/deadlockcauser.jar:$TIDORBJ_HOME/lib/tidorbj_contest.jar \
    -Dorg.omg.CORBA.ORBClass=es.tid.TIDorbj.core.TIDORB \
    -Dorg.omg.CORBA.ORBSingletonClass=es.tid.TIDorbj.core.SingletonORB \
    server_ServantLocator \
    es.tid.TIDorbj.typecode_cache_size 1000 \
    es.tid.TIDorbj.iiop.max_connections 25 \
    es.tid.TIDorbj.max_blocked_time 5000000 \
    es.tid.TIDorbj.trace.file server_ServantLocator.log \
    es.tid.TIDorbj.trace.level 0 &
server_ServantLocator_pid=$!
sleep 10

$JVM -classpath .:$CONTEST_HOME/Lib/ConTest.jar:$CONTEST_HOME/Lib/racedetector.jar:$CONTEST_HOME/Lib/deadlockcauser.jar:$TIDORBJ_HOME/lib/tidorbj_contest.jar \
    -Dorg.omg.CORBA.ORBClass=es.tid.TIDorbj.core.TIDORB \
    -Dorg.omg.CORBA.ORBSingletonClass=es.tid.TIDorbj.core.SingletonORB \
    Client \
    es.tid.TIDorbj.max_blocked_time 5000000 \
    es.tid.TIDorbj.trace.file client_ServantLocator.log \
    es.tid.TIDorbj.trace.level 0 
sleep 2
kill $server_ServantLocator_pid


