import java.io.*;
import java.util.Properties;

import org.omg.CORBA_2_3.ORB;
import org.omg.CORBA.Any;
import org.omg.CORBA.Object;
import org.omg.CORBA.Request;
import org.omg.CORBA.StructMember;
import org.omg.CORBA.TypeCode;
import org.omg.DynamicAny.DynAny;
import org.omg.DynamicAny.DynAnyFactory;
import org.omg.DynamicAny.DynAnyFactoryHelper;
import org.omg.DynamicAny.DynStruct;
import org.omg.DynamicAny.DynStructHelper;
import org.omg.DynamicAny.NameDynAnyPair;
import org.omg.DynamicAny.NameValuePair;

import Echo.Bar;
import Echo.BarHelper;
import Echo.ExampleEvent;
import Echo.Foo;
import Echo.FooHelper;
import Marshalling.RadarTrack;

/*
 * MORFEO Project
 * http://www.morfeo-project.org
 *
 * Component: TIDorbJTest_Java
 * Programming Language: Java
 *
 * File: $Source: EchoClient.java $
 * Version: $Revision: 1.0 $
 * Date: $Date: 14-ago-2006 $
 * Last modified by: $Author: irenka.redondo $
 *
 * (C) Copyright 2004 Telefnica Investigacin y Desarrollo
 *     S.A.Unipersonal (Telefnica I+D)
 *
 * Info about members and contributors of the MORFEO project
 * is available at:
 *
 *   http://www.morfeo-project.org/TIDorbJ/CREDITS
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * If you want to use this software an plan to distribute a
 * proprietary application in any way, and you are not licensing and
 * distributing your source code under GPL, you probably need to
 * purchase a commercial license of the product.  More info about
 * licensing options is available at:
 *
 *   http://www.morfeo-project.org/TIDorbJ/Licensing
 */
public class EchoClient {
	
    //static final int OBJREF_BUFFER_SIZE = 1000;
    private static Foo foo_ref = null;
    private static Bar bar_ref = null;
	
    void terminarEjecucion (int a) {
        this.foo_ref.shutdown();
        System.exit(0);
    }
	
    static String buildString (int n) {
        String c = new String();
        for (int i=0; i<n; i++)
            c = c + "a";
        return c;
    }
	
    public static void main(String args[]) {

        // Identificador del servidor
        String client_name = "EchoClient";

    	try {

            // Create and initialize orb
            /*
            Properties props = new Properties();
            props.setProperty("org.omg.CORBA.ORBClass", 
                              "es.tid.TIDorbj.core.TIDORB");
            props.setProperty("org.omg.CORBA.ORBSingletonClass", 
                              "es.tid.TIDorbj.core.SingletonORB");
            props.setProperty("es.tid.TIDorbj.trace.level", "4");
            props.setProperty("es.tid.TIDorbj.trace.file", "client.log");
            props.setProperty("es.tid.TIDorbj.max_blocked_time", "5000000");
            */
            //org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,props);
            org.omg.CORBA_2_3.ORB orb = 
                (org.omg.CORBA_2_3.ORB) org.omg.CORBA.ORB.init(args,System.getProperties());

            //
            // Get iors...
            //
            String foo_ior_str = null;
            String bar_ior_str = null;
            String foo_ior_file_name = "Foo.ior";
            String bar_ior_file_name = "Bar.ior";
            File foo_ior_file = new File(foo_ior_file_name);
            File bar_ior_file = new File(bar_ior_file_name);


            // Foo ior
            if (foo_ior_file.exists()) { //ior in file
                try {
                    BufferedReader br = new BufferedReader(new FileReader(foo_ior_file));
                    foo_ior_str = br.readLine();
                    br.close();
                } catch (java.io.IOException e) {
                    System.err.println("Error reading file " + foo_ior_file_name);
                    System.exit(1);
                }
            }
            else {
                System.err.println("File " + foo_ior_file_name + " not exista");
                System.exit(1);
            }

            // Bar ior
            if (bar_ior_file.exists()) { //ior in file
                try {
                    BufferedReader br = new BufferedReader(new FileReader(bar_ior_file));
                    bar_ior_str = br.readLine();
                    br.close();
                } catch (java.io.IOException e) {
                    System.err.println("Error reading file " + bar_ior_file_name);
                    System.exit(1);
                }
            }
            else {
                System.err.println("File " + bar_ior_file_name + " not exista");
                System.exit(1);
            }




            // Registro de la factora de Valuetypes
            org.omg.CORBA.portable.ValueFactory factory = new ExampleEventInitImpl();
            String rep_id = Echo.ExampleEventHelper.id();
            orb.register_value_factory(rep_id, factory);
	   			
            // Get object references...
            org.omg.CORBA.Object obj1 = orb.string_to_object(foo_ior_str);
            foo_ref = FooHelper.narrow(obj1);

            org.omg.CORBA.Object obj2 = orb.string_to_object(bar_ior_str);
            bar_ref = BarHelper.narrow(obj2);


            

            //            
            // Prueba de DII
            //
            for (int i=0; i<10; i++) {
                boolean result;
                Request request = obj1._request("op2");
        		
                //Set arguments
                Any miArgumento = request.add_in_arg();
                miArgumento.insert_long(4);

                //Set return type
                request.set_return_type(
                       org.omg.CORBA.ORB.init().get_primitive_tc(
                                          org.omg.CORBA.TCKind.tk_boolean));
        		
                //Invoke request
                request.invoke();
        		
                //Check for exceptions
                Exception exception = request.env().exception();
                if (exception != null)
                    throw (org.omg.CORBA.SystemException)exception;
       	    	//If no exceptions, process return values
                result = request.return_value().extract_boolean();
                if (!result)
                    System.err.println("[client] DII invoke return false");
            }
            System.err.println("[client] PASS DII invokes");
   	    	



//             //
//             // Prueba de DynamicAny
//             //
//             Object daf_ref = orb.resolve_initial_references("DynAnyFactory");
//             DynAnyFactory daf = DynAnyFactoryHelper.narrow(daf_ref);
   	    	
//             for (int i=0; i<20; i++) {
//                 // Crea una secuencia que contiene las definiciones 
//                 // para los cuatro miembros de la estructura
//                 StructMember [] mseq = new StructMember[2];

//                 mseq[0].name = "true_bool_value";
//                 mseq[0].type = org.omg.CORBA.ORB.init().get_primitive_tc(
//                                                   org.omg.CORBA.TCKind.tk_boolean);
//                 mseq[1].name = "false_bool_value";
//                 mseq[1].type = org.omg.CORBA.ORB.init().get_primitive_tc(
//                                                   org.omg.CORBA.TCKind.tk_boolean);
   	    		
//                 //Crea un cdigo de tipo para la estructura BtData
//                 TypeCode my_struct_tc = orb.create_struct_tc("IDL:UnknowStructName:1.0", 
//                                                              "UnknowStructName", mseq);
   	    		
//                 //Crea un DynStruct
//                 DynAny da = daf.create_dyn_any_from_type_code(my_struct_tc);
//                 DynStruct ds = DynStructHelper.narrow(da);
   	    		
//                 // METODO 1:
//                 // - Inicia los miembros del DynStruct utilizando iteracin
//                 ds.rewind();
//                 ds.insert_boolean(true);
//                 ds.next();
//                 ds.insert_boolean(false);
//                 ds.rewind();
   	    		
//                 // METODO 2:
//                 // -Inicializa los miembros del DynStruct con DynAnys
//                 DynAny true_bool_value = 
//                     daf.create_dyn_any_from_type_code(
//                              org.omg.CORBA.ORB.init().get_primitive_tc(
//                                                         org.omg.CORBA.TCKind.tk_boolean));
//                 true_bool_value.insert_boolean(true);
   	    		
//                 DynAny false_bool_value = 
//                     daf.create_dyn_any_from_type_code(
//                              org.omg.CORBA.ORB.init().get_primitive_tc(
//                                                         org.omg.CORBA.TCKind.tk_boolean));
//                 false_bool_value.insert_boolean(false);
   	    		
//                 NameDynAnyPair [] miembros = new NameDynAnyPair[2];
//                 miembros[0].id = "true_bool_value";
//                 miembros[0].value = true_bool_value;
//                 miembros[1].id = "false_bool_value";
//                 miembros[1].value = false_bool_value;
   	    		
//                 ds.set_members_as_dyn_any(miembros);
   	    		
//                 ds.rewind();
   	    		
// //                 // METODO 3:
// //                 // - Inicializa los miembros del DynStruct con get y set members
// //                 NameValuePair [] member_values, member_values2;
   	    		
// //                 member_values = ds.get_members();
// //                 member_values[0].value.insert_boolean(true);
// //                 member_values[1].value.insert_boolean(false);
// //                 ds.set_members(member_values);
   	    		
// //                 member_values2 = ds.get_members();
   	    		
// //                 boolean bval1 = member_values2[0].value.extract_boolean();
// //                 if (!bval1)
// //                     System.err.println("WARNING WARNING original and inserted any values are different");
   	    		
// //                 ds.set_members(member_values2);
// //                 ds.set_members(member_values);
   	    		
// //                 Any btd = ds.to_any();
// //                 ds.rewind();

//             }
//             System.err.println("[client] PASS Dynamic Any ops");


   	    		
            //int num = 65536;
            int num = 16384;
  	    		
            String cadena = null;
            String cadena2 = "Hola, mundo";
            cadena = buildString(num);
            System.err.println("[client] cadena.length()=" + cadena.length());
   	    		
            //Any any = new AnyImpl(orb), any2 = new AnyImpl(orb), any3 = new AnyImpl(orb);
            Any any = orb.create_any();
            Any any2 = orb.create_any();
            Any any3 = orb.create_any();
   	    	
            ExampleEvent exampleEvt = new ExampleEventImpl();
            Marshalling.RadarTrack track = new RadarTrack();
//             MW_Invocation.InvocationRequest inv = new MW_Invocation.InvocationRequest();
//             inv.header.invPid = 1;
//             inv.header.invHost = "host";
//             inv.header.ck = 1;
//             inv.header.invItfType = "Type";
//             inv.body.invocation = "NameInvocation";
//             inv.body.arguments = new Any [0];

   	    		
            for (int i=0; i<300; i++) {
                try {

                    any.insert_string(cadena);
                    foo_ref.push(any);
                    bar_ref.push(any);

                    //bar_ref.push_invocation(inv); // NO IMPLEMENTED
                    
//                     any.insert_string(cadena2);
//                     exampleEvt.data = any;
//                     exampleEvt.sender = "sender";
//                     exampleEvt.message = "message";
//                     any2.insert_Value(exampleEvt);

//                     System.err.println("[client] foo_ref.push2");
//                     foo_ref.push2(any2);

//                     System.err.println("[client] foo_ref.push3");
//                     foo_ref.push3(any2);
//                     System.err.println("[client] bar_ref.push3");
//                     bar_ref.push3(any2);
   	    			
//                     track.track_id = i;
//                     Marshalling.RadarTrackHelper.insert(any3,track);
//                     System.err.println("[client] foo_ref.push_radar");
//                     foo_ref.push_radar(any3);

                } catch (Exception exc) {
                    System.err.println("[client] Excepcion: " + exc.getMessage());
                    System.exit(0);
                }
            } // for
   	    		
            try {
                foo_ref.op();
            } catch (Echo.FooException e) {
                System.err.println("[client] Ok. FooExcepcion catched ");
            }
            
   	    		
            System.err.println("[client] Terminado con todo");
   	    	
            foo_ref.shutdown();

            Thread.sleep(3000); // sleep 3 seconds

            orb.destroy();
    	}
    	catch (Exception e) {
            System.err.println("[client] Excepcion: " + e.getMessage());
    	}
    }
}

// class MyClientThread extends Thread {
//     public Foo m_foo_ref;
//     public ExampleEvent exampleEvt;
//     public Marshalling.RadarTrack track;
//     public Any any, any2, any3;
	
//     public MyClientThread(Foo ref) {
//         this.m_foo_ref = ref;
//     }
	
//     public void run() {
//         for(int i=0; i<10; i++) {
//             String cadena = "Hola, mundo ";
//             String cadena2 = "Hola, mundo2";
//             any.insert_string(cadena);
//             m_foo_ref.push(any);
//             any.insert_string(cadena2);
//             exampleEvt.data = any;
//             any2 = exampleEvt.data;
//             m_foo_ref.push2(any2);
			
//             track.track_id = i;
//             any3.insert_Value(track);
//             m_foo_ref.push_radar(any3);
//         }
//     }
// }

