import java.io.*;
import java.util.Properties;

import org.omg.CORBA.Any;
import org.omg.CORBA.ORB;
import org.omg.CORBA.Object;
import org.omg.CORBA.Policy;
import org.omg.IOP.Codec;
import org.omg.IOP.CodecFactory;
import org.omg.IOP.CodecFactoryHelper;
import org.omg.IOP.ENCODING_CDR_ENCAPS;
import org.omg.IOP.Encoding;
import org.omg.PortableServer.IdAssignmentPolicyValue;
import org.omg.PortableServer.LifespanPolicyValue;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAHelper;
import org.omg.PortableServer.POAManager;
import org.omg.PortableServer.RequestProcessingPolicyValue;
import org.omg.PortableServer.ServantRetentionPolicyValue;

import Echo.Bar;
import Echo.BarHelper;
import Echo.Foo;
import Echo.Foo2;
import Echo.Foo2Helper;
import Echo.FooHelper;
import Echo.FooMIOP;
import Echo.FooMIOPHelper;

/*
 * MORFEO Project
 * http://www.morfeo-project.org
 *
 * Component: TIDorbJTest_Java
 * Programming Language: Java
 *
 * File: $Source: EchoServer.java $
 * Version: $Revision: 1.0 $
 * Date: $Date: 16-ago-2006 $
 * Last modified by: $Author: irenka.redondo $
 *
 * (C) Copyright 2004 Telefnica Investigacin y Desarrollo
 *     S.A.Unipersonal (Telefnica I+D)
 *
 * Info about members and contributors of the MORFEO project
 * is available at:
 *
 *   http://www.morfeo-project.org/TIDorbJ/CREDITS
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * If you want to use this software an plan to distribute a
 * proprietary application in any way, and you are not licensing and
 * distributing your source code under GPL, you probably need to
 * purchase a commercial license of the product.  More info about
 * licensing options is available at:
 *
 *   http://www.morfeo-project.org/TIDorbJ/Licensing
 */
public class EchoServer {

    static String buildString (int n) {
        String c = new String();
        for (int i=0; i<n; i++)
            c = c + "a";
        return c;
    }
	
    public static void main(String[] args) {
        // Identificador del servidor
        String server_name = "EchoServer";

        try {
            // Create and initialize orb
            /*
            Properties props = new Properties();
            props.setProperty("org.omg.CORBA.ORBClass", 
                              "es.tid.TIDorbj.core.TIDORB");
            props.setProperty("org.omg.CORBA.ORBSingletonClass", 
                              "es.tid.TIDorbj.core.SingletonORB");
            props.setProperty("es.tid.TIDorbj.trace.level", "4");
            props.setProperty("es.tid.TIDorbj.trace.file", "server.log");

            ORB orb = ORB.init(args, props);
            */
            org.omg.CORBA_2_3.ORB orb = 
                (org.omg.CORBA_2_3.ORB) org.omg.CORBA.ORB.init(args,System.getProperties());

            // Obtiene referencias al rootPOA y su POAManager
            Object obj = orb.resolve_initial_references("RootPOA");
            POA rootpoa = POAHelper.narrow(obj);
            POAManager rootpoamgr = rootpoa.the_POAManager();
			
            // Obtiene codec factory
            obj = orb.resolve_initial_references("CodecFactory");
            CodecFactory codec_factory = CodecFactoryHelper.narrow(obj);
			
            // Crea codec
            Encoding encoding = new Encoding();
            encoding.format = ENCODING_CDR_ENCAPS.value;
            encoding.major_version = 1;
            encoding.minor_version = 2;
            Codec codec = codec_factory.create_codec(encoding);
			


            //
            // Get ior...
            //
            String foo2_ior_str = null;
            String foo2_ior_file_name = "Foo2.ior";
            File foo2_ior_file = new File(foo2_ior_file_name);

            // Foo2 ior
            if (foo2_ior_file.exists()) { //ior in file
                try {
                    BufferedReader br = new BufferedReader(new FileReader(foo2_ior_file));
                    foo2_ior_str = br.readLine();
                    br.close();
                } catch (java.io.IOException e) {
                    System.err.println("[" + server_name + "] Error reading file " + 
                                       foo2_ior_file_name);
                    System.exit(1);
                }
            }
            else {
                System.err.println("File " + foo2_ior_file_name + " not exista");
                System.exit(1);
            }

   			
            // Particulariza la referencia
            Object obj4 = orb.string_to_object(foo2_ior_str);
            Foo2 foo2_ref = Foo2Helper.narrow(obj4);
   			
            // Crea un servant de la interfaz Echo.FooMIOP
            FooMIOPImpl servantFooMIOP = 
                new FooMIOPImpl(server_name, orb, codec, foo2_ref);
   			
            // Activa el servant en el RootPOA
            byte[] servantId = rootpoa.activate_object(servantFooMIOP);
            obj = rootpoa.id_to_reference(servantId);
            FooMIOP fooMIOP_ref = FooMIOPHelper.narrow(obj);



//             Policy [] _policies = new Policy [4];
//             _policies[0] = rootpoa.create_lifespan_policy(LifespanPolicyValue.PERSISTENT);
//             _policies[1] = rootpoa.create_request_processing_policy(RequestProcessingPolicyValue.USE_DEFAULT_SERVANT);
//             _policies[2] = rootpoa.create_id_assignment_policy(IdAssignmentPolicyValue.USER_ID);
//             _policies[3] = rootpoa.create_servant_retention_policy(ServantRetentionPolicyValue.NON_RETAIN);
   			
//             POA factory_poa = rootpoa.create_POA("WorkPOA", rootpoamgr, _policies);
   			
//             // creacion poa para prodcutores
//             Policy [] _policies_productores = new Policy[1];
//             _policies_productores[0] = rootpoa.create_id_assignment_policy(IdAssignmentPolicyValue.USER_ID);
   			
//             POA _productores_poa = rootpoa.create_POA("ProductoresPOA", rootpoamgr, _policies_productores);
   			
//             String id = "Factoria";
//             byte[] _object_id = id.getBytes();
   			
//             FactoriaImpl _factoria_impl = new FactoriaImpl (orb, _productores_poa);
//             factory_poa.set_servant(_factoria_impl);
//             obj = factory_poa.create_reference_with_id(_object_id, "IDL:Echo/Factoria:1.0");
//             String ior = orb.object_to_string(obj);
   			
//             File ior_fl = new File("factory.ior");
//             try {
//                 BufferedWriter bw = new BufferedWriter(new FileWriter(ior_fl));
//                 bw.write(ior, 0, ior.length());
//                 bw.flush();
//                 bw.close();
//             } catch (java.io.IOException e) {
//                 System.err.println("Error writing file factory.ior");
//                 return;
//             }
   			
//             System.err.println("Factory Server Ready");


			

            // Crea un servant de la interfaz Echo.Foo
            FooImpl servant = new FooImpl(server_name, orb, rootpoa, codec, fooMIOP_ref);
            byte [] oid3 = rootpoa.activate_object(servant);
   			
            Object obj10 = rootpoa.id_to_reference(oid3);
            Foo foo_ref = FooHelper.narrow(obj10);
   			
            String foo_str_ref = orb.object_to_string(foo_ref);

            // Get servant reference and write it to file
            String foo_ior_file_name = "Foo.ior";
            File foo_ior_file = new File(foo_ior_file_name);
            try {
                BufferedWriter bw = new BufferedWriter(new FileWriter(foo_ior_file));
                bw.write(foo_str_ref, 0, foo_str_ref.length());
                bw.flush();
                bw.close();
            } catch (java.io.IOException e) {
                System.err.println("[" + server_name + "] Error writing file " + 
                                   foo_ior_file_name);
                System.exit(0);
            }


            rootpoamgr.activate();
   			
            System.err.println("[" + server_name + "] ORB1 preparado...");



            // Creacin del ORB2
            String[] args2 = { "-ORBid", "ORB_2" };

            Properties props = new Properties();
            props.setProperty("org.omg.CORBA.ORBClass", 
                              "es.tid.TIDorbj.core.TIDORB");
            props.setProperty("org.omg.CORBA.ORBSingletonClass", 
                              "es.tid.TIDorbj.core.SingletonORB");
            props.setProperty("es.tid.TIDorbj.trace.level", "0");
            props.setProperty("es.tid.TIDorbj.trace.file", "server_orb2.log");
            props.setProperty("es.tid.TIDorbj.max_blocked_time","5000000");
            props.setProperty("es.tid.TIDorbj.typecode_cache_size","1000");

            org.omg.CORBA_2_3.ORB orb2 = (org.omg.CORBA_2_3.ORB) ORB.init(args2, props);
   			
            obj = orb2.resolve_initial_references("RootPOA");
            POA rootpoa2 = POAHelper.narrow(obj);
            POAManager rootpoamgr2 = rootpoa2.the_POAManager();
   			
            // Obtiene codec factory
            obj = orb2.resolve_initial_references("CodecFactory");
            CodecFactory codec_factory2 = CodecFactoryHelper.narrow(obj);
   			
            // Crea codec
            Encoding encoding2 = new Encoding();
            encoding2.format = ENCODING_CDR_ENCAPS.value;
            encoding2.major_version = 1;
            encoding2.minor_version = 2;
            Codec codec2 = codec_factory2.create_codec(encoding2);
   			
            Object obj13 = orb2.string_to_object(foo_str_ref);
            Foo foo_ref2 = FooHelper.narrow(obj13);
   			
            BarImpl servantBar = new BarImpl(server_name, orb2, rootpoa2, 
                                             codec2, foo_ref2, foo2_ref, fooMIOP_ref);
            byte [] bar_oid = rootpoa2.activate_object(servantBar);

            Object obj5 = rootpoa2.id_to_reference(bar_oid);
            Bar bar_ref = BarHelper.narrow(obj5);
   			
            String bar_str_ref = orb2.object_to_string(bar_ref);
   			
            File bar_ior_file = new File("Bar.ior");
            try {
                BufferedWriter bw = new BufferedWriter(new FileWriter(bar_ior_file));
                bw.write(bar_str_ref, 0, bar_str_ref.length());
                bw.flush();
                bw.close();
            } catch (java.io.IOException e) {
                System.err.println("[" + server_name + "] Error writing file Bar.ior");
                return;
            }
   			
            rootpoamgr2.activate();
            System.err.println("[" + server_name + "] ORB2 preparado...");
			



            //
            // Invocacion local con any
            //
            System.err.println("[" + server_name + "] 15 Local invokes: echo(any)");
            int num = 2000;
            String cadena = null;
            cadena = buildString(num);
            //String cadena = "Hola";
            System.err.println("[" + server_name + "] cadena.length() = " + cadena.length());
            for (int i=0; i<15; i++) {
                //Invoca la operacion echo()
                Any a = orb2.create_any();
                a.insert_string(cadena);
                String str = foo_ref.echo(a);
            }
			
            System.err.println("[" + server_name + "] 15 Local invokes ended");



            orb.run();
		

	
            orb.destroy();
            System.err.println("[" + server_name + "] ORB1 destruido"); 

            orb2.destroy();
            System.err.println("[" + server_name + "] ORB2 destruido");
			
        } catch (Exception e) {
            System.err.println("[" + server_name + "] Excepcion: " + e.getMessage());
        }
    }

}
