/*
 * MORFEO Project
 * http://www.morfeo-project.org
 *
 * Component: TIDorbJTest_Java
 * Programming Language: Java
 *
 * File: $Source: EchoServer2.java $
 * Version: $Revision: 1.0 $
 * Date: $Date: 17-ago-2006 $
 * Last modified by: $Author: irenka.redondo $
 *
 * (C) Copyright 2004 Telefnica Investigacin y Desarrollo
 *     S.A.Unipersonal (Telefnica I+D)
 *
 * Info about members and contributors of the MORFEO project
 * is available at:
 *
 *   http://www.morfeo-project.org/TIDorbJ/CREDITS
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * If you want to use this software an plan to distribute a
 * proprietary application in any way, and you are not licensing and
 * distributing your source code under GPL, you probably need to
 * purchase a commercial license of the product.  More info about
 * licensing options is available at:
 *
 *   http://www.morfeo-project.org/TIDorbJ/Licensing
 */
import java.io.*;
import java.util.Properties;

import org.omg.CORBA.ARG_IN;
import org.omg.CORBA.Any;
import org.omg.CORBA.Environment;
import org.omg.CORBA.NVList;
import org.omg.CORBA.NamedValue;
import org.omg.CORBA_2_3.ORB;
import org.omg.CORBA.Object;
import org.omg.CORBA.ServerRequest;
import org.omg.DynamicAny.DynAny;
import org.omg.DynamicAny.DynAnyFactory;
import org.omg.DynamicAny.DynAnyFactoryHelper;
import org.omg.PortableServer.DynamicImplementation;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAHelper;
import org.omg.PortableServer.POAManager;

import Echo.Foo2;
import Echo.Foo2Helper;
import Echo.Server;
import Echo.ServerHelper;
import Echo.miItfHelper;


public class EchoServer2 {
	
    public static void main(String[] args) {

        // Identificador del servidor
        String server_name = "EchoServer2";
		
        try {
            // Inicializa el orb
            /*
            Properties props = new Properties();
            props.setProperty("org.omg.CORBA.ORBClass", 
                              "es.tid.TIDorbj.core.TIDORB");
            props.setProperty("org.omg.CORBA.ORBSingletonClass", 
                              "es.tid.TIDorbj.core.SingletonORB");
            props.setProperty("es.tid.TIDorbj.trace.level", "4");
            props.setProperty("es.tid.TIDorbj.trace.file", "server2.log");
            */
            //ORB orb = ORB.init(args, props);
            org.omg.CORBA_2_3.ORB orb = 
                (org.omg.CORBA_2_3.ORB) org.omg.CORBA.ORB.init(args,System.getProperties());

            // Obtiene referencias al rootPOA y su POAManager
            Object obj = orb.resolve_initial_references("RootPOA");
            POA rootpoa = POAHelper.narrow(obj);
            POAManager rootpoamgr = rootpoa.the_POAManager();
			
            // Registro de la factora de Valuetypes
            org.omg.CORBA.portable.ValueFactory factory = new ExampleEventInitImpl();
            String rep_id = Echo.ExampleEventHelper.id();
            orb.register_value_factory(rep_id, factory);
			
            // Crea un servant de la interfaz Echo.Foo2
            Foo2Impl servant = new Foo2Impl(server_name, orb);
			
            // Activa el servant en el RootPOA
            byte [] oid = rootpoa.activate_object(servant);
			
            Object obj2 = rootpoa.id_to_reference(oid);
            Foo2 foo2_ref = Foo2Helper.narrow(obj2);
			
            // Vuelca en salida estndar la referencia como cadena de caracteres
            String foo2_str_ref = orb.object_to_string(foo2_ref);

            // Get servant reference and write it to file
            String foo2_ior_file_name = "Foo2.ior";
            File foo2_ior_file = new File(foo2_ior_file_name);
            try {
                BufferedWriter bw = new BufferedWriter(new FileWriter(foo2_ior_file));
                bw.write(foo2_str_ref, 0, foo2_str_ref.length());
                bw.flush();
                bw.close();
            } catch (java.io.IOException e) {
                System.err.println("[" + server_name + "] Error writing file " + 
                                   foo2_ior_file_name);
                System.exit(0);
            }

			
            // Activa el RootPOAManager
            rootpoamgr.activate();
   			
            // Acepta peticiones
            System.err.println("[" + server_name + "] preparado...");


            // 
            // DSI
            //
            MyDSIServant dsi_servant = new MyDSIServant(orb);
   			
            byte [] oid2 = rootpoa.activate_object(dsi_servant);
            Object obj3 = rootpoa.id_to_reference(oid2);
   			
            Server example = ServerHelper.narrow(obj3);
   			
            for (int i=0; i<5; i++)
                example.get_Itf(null);




            System.err.println("[" + server_name + "] esperando peticiones...");
            orb.run();
			
            orb.destroy();

        } catch (Exception e) {
            System.err.println("[" + server_name + "] Excepcion: " + e.getMessage());
        }
    }

}

class MyDSIServant extends DynamicImplementation {
	
    private String r_itf;
    private ORB m_orb;

    public MyDSIServant(ORB orb) {
        this.r_itf = "IDL:Echo/Server:1.0";
        this.m_orb = orb;
    }
	
    void is_a (ServerRequest request) {
        System.err.println("is_a");
    }
	
    public void non_existent(ServerRequest request) {
    }
	
    public void invoke(ServerRequest serverRequest, Environment env) {
        invoke(serverRequest);
    }

    public void invoke(ServerRequest serverRequest) {
        int modo = 0;
        NVList _params = m_orb.create_list(1);
        NVList _params2 = m_orb.create_list(1);
		
        switch (modo) {
        case 0:
            try {
                NamedValue __d = _params.add_item("d", ARG_IN.value);
                __d.value().type(miItfHelper.type());
                serverRequest.arguments(_params);
                modo++;
            } catch (Exception e) {
                System.err.println("ERROR invocando en modo TIDorb");
            }
            break;
        case 1:
            try {
                modo++;
                Any arg_miInterfaz = m_orb.create_any();
                arg_miInterfaz.type(miItfHelper.type());
					
                if (arg_miInterfaz.type() != miItfHelper.type()) {
                    System.err.println("ERROR: el tipo no encaja");
                    System.err.println("ERROR: el tipo es " + arg_miInterfaz.type().name()); 
                }
				
                _params.add_value("miInterfaz", arg_miInterfaz, ARG_IN.value);
                serverRequest.arguments(_params);
            } catch (Exception e) {
                System.err.println("ERROR invocando en modo OMG no muy standard");
            }
            break;
        default:
            try {
                Object objV = m_orb.resolve_initial_references("DynAnyFactory");
                DynAnyFactory dynFactoryV = DynAnyFactoryHelper.narrow(objV);
					
                DynAny dynAny = dynFactoryV.create_dyn_any_from_type_code(miItfHelper.type());
                Any arg_miInterfaz = dynAny.to_any();
					
                if (arg_miInterfaz.type() != miItfHelper.type()) {
                    System.err.println("ERROR: el tipo no encaja");
                    System.err.println("ERROR: el tipo es " + arg_miInterfaz.type().name()); 
                }
					
                _params.add_value("miInterfaz", arg_miInterfaz, ARG_IN.value);
                serverRequest.arguments(_params);
            } catch (Exception e) {
                System.err.println("ERROR invocando en modo OMG standard");
            }
            break;
        } // switch
    }
	
    public String _primary_interface (byte [] oid, POA poa, Environment env) {
        return _primary_interface (oid, poa);
    }

    public String _primary_interface (byte [] oid, POA poa) {
        return r_itf;
    }
	
    public boolean _is_a (String logical_type_id) {
        boolean rv = false;
        if (logical_type_id.equals(r_itf)) 
            rv = true;
		
        if (!rv)
            System.err.println("_is_a " + logical_type_id + "? False");
        else
            System.err.println("_is_a " + logical_type_id + "? True");
		
        return rv;
    }

    public String[] _all_interfaces(POA poa, byte[] objectId) {
        String [] ifaces = {this.r_itf};
        return ifaces;
    }
	
} // class MyDSIServant


