import Echo.CannotCreate;
import Echo.FactoriaPOA;
import Echo.ProductorMessage;
/*
 * MORFEO Project
 * http://www.morfeo-project.org
 *
 * Component: TIDorbJTest_Java
 * Programming Language: Java
 *
 * File: $Source: FactoriaImpl.java $
 * Version: $Revision: 1.0 $
 * Date: $Date: 11-ago-2006 $
 * Last modified by: $Author: irenka.redondo $
 *
 * (C) Copyright 2004 Telefnica Investigacin y Desarrollo
 *     S.A.Unipersonal (Telefnica I+D)
 *
 * Info about members and contributors of the MORFEO project
 * is available at:
 *
 *   http://www.morfeo-project.org/TIDorbJ/CREDITS
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * If you want to use this software an plan to distribute a
 * proprietary application in any way, and you are not licensing and
 * distributing your source code under GPL, you probably need to
 * purchase a commercial license of the product.  More info about
 * licensing options is available at:
 *
 *   http://www.morfeo-project.org/TIDorbJ/Licensing
 */
public class FactoriaImpl extends FactoriaPOA {

	private org.omg.CORBA.ORB m_orb;
	private org.omg.PortableServer.POA m_poa;
	
	public FactoriaImpl(org.omg.CORBA.ORB orb, org.omg.PortableServer.POA poa) {
		this.m_orb=orb;
		this.m_poa=poa;
	}
	
	public ProductorMessage create_productor() throws CannotCreate {
		try {
			System.err.println("[FactoriaImpl] create_productor 0");
			ProductorMessageImpl servant = new ProductorMessageImpl(this.m_orb, this.m_poa);
			ProductorMessage productor = servant._this();
			return productor;
		} catch (org.omg.CORBA.SystemException e) {
			throw new CannotCreate(e.getMessage());
		}
	}

}
