import org.omg.CORBA.Any;

import Echo.ExampleEvent;
import Echo.Foo2POA;
/*
 * MORFEO Project
 * http://www.morfeo-project.org
 *
 * Component: TIDorbJTest_Java
 * Programming Language: Java
 *
 * File: $Source: Foo2Impl.java $
 * Version: $Revision: 1.0 $
 * Date: $Date: 14-ago-2006 $
 * Last modified by: $Author: irenka.redondo $
 *
 * (C) Copyright 2004 Telefnica Investigacin y Desarrollo
 *     S.A.Unipersonal (Telefnica I+D)
 *
 * Info about members and contributors of the MORFEO project
 * is available at:
 *
 *   http://www.morfeo-project.org/TIDorbJ/CREDITS
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * If you want to use this software an plan to distribute a
 * proprietary application in any way, and you are not licensing and
 * distributing your source code under GPL, you probably need to
 * purchase a commercial license of the product.  More info about
 * licensing options is available at:
 *
 *   http://www.morfeo-project.org/TIDorbJ/Licensing
 */
public class Foo2Impl extends Foo2POA {

    private org.omg.CORBA.ORB m_orb;
    private int count;
	
    public Foo2Impl (String server_name, org.omg.CORBA.ORB orb) {
        String buffer;
        System.err.println("[Foo2Impl] creating Foo2Impl");
        this.m_orb = orb;
        this.count = 0;
    }
	
    public void push(Any value) {
        String cadena;
        org.omg.CORBA.TypeCode type = value.type();
        org.omg.CORBA.TCKind tc_kind = type.kind();
		
        if (tc_kind == org.omg.CORBA.TCKind.tk_string)
            cadena = value.extract_string();
        else {
            // No ha llegado el 2 Any
            System.err.println("[Foo2Impl push] return: Falso");
            return;
        }
        if (this.count%10 == 0)
            System.err.println("[Foo2Impl push] longitud del string del any: " + cadena.length());
    }

    public void push2(Any value) {
        Echo.ExampleEvent exampleEvt;

        exampleEvt = Echo.ExampleEventHelper.extract(value);

        String cadena, cadena2;
		
        org.omg.CORBA.Any any = exampleEvt.data;
        cadena2 = exampleEvt.sender;

	cadena = any.extract_string();
        
        if (this.count%10 == 0)
            System.err.println("[Foo2Impl push "+ count + "] string " + cadena);

		
    }

    public void push3(Any value) {
        // TODO Auto-generated method stub
        count++;

    }

    public void push_invocation(Any value) {

    }

    public void push_radar(Any value) {

        Marshalling.RadarTrack radar;

        radar = Marshalling.RadarTrackHelper.extract(value);

        if (this.count%10 == 0)
             System.err.println("[Foo2Impl push] valor del any: " + radar.track_id);
        
    }

    public void shutdown() {
        System.err.println("[Foo2Impl shutdown] called");
        try {
            Thread.sleep(3000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        this.m_orb.shutdown(true);
    }

}
