import org.omg.CORBA.Any;
import org.omg.IOP.CodecPackage.InvalidTypeForEncoding;

import Echo.FooException;
import Echo.FooPOA;
import Echo._ReliablePackage;
/*
 * MORFEO Project
 * http://www.morfeo-project.org
 *
 * Component: TIDorbJTest_Java
 * Programming Language: Java
 *
 * File: $Source: FooImpl.java $
 * Version: $Revision: 1.0 $
 * Date: $Date: 14-ago-2006 $
 * Last modified by: $Author: irenka.redondo $
 *
 * (C) Copyright 2004 Telefnica Investigacin y Desarrollo
 *     S.A.Unipersonal (Telefnica I+D)
 *
 * Info about members and contributors of the MORFEO project
 * is available at:
 *
 *   http://www.morfeo-project.org/TIDorbJ/CREDITS
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * If you want to use this software an plan to distribute a
 * proprietary application in any way, and you are not licensing and
 * distributing your source code under GPL, you probably need to
 * purchase a commercial license of the product.  More info about
 * licensing options is available at:
 *
 *   http://www.morfeo-project.org/TIDorbJ/Licensing
 */

public class FooImpl extends FooPOA {
	
    private org.omg.CORBA.ORB m_orb;
    private org.omg.PortableServer.POA m_poa;
    private Echo.FooMIOP m_fooMIOP_ref;
    private org.omg.IOP.Codec m_codec;
    private int count;
	
    public FooImpl (String server_name, 
                    org.omg.CORBA.ORB orb, 
                    org.omg.PortableServer.POA poa,
                    org.omg.IOP.Codec codec, 
                    Echo.FooMIOP fooMIOP_ref) {

        String buffer;
        System.err.println("[FooImpl] creating FooImpl");
        this.m_orb = orb;
        this.m_poa = poa;
        this.m_fooMIOP_ref = fooMIOP_ref;
        this.m_codec = codec;
        this.count = 0;
    }

    public void push(Any value) {
        // Encode
        try {
            byte [] buffer = this.m_codec.encode(value);
            this.m_fooMIOP_ref.push(buffer);
        } catch (InvalidTypeForEncoding e) {
            e.printStackTrace();
        } 	
    }

    public void push2(Any value) {
        Echo._ReliablePackage pack = new _ReliablePackage();
        Echo.UdprLibHeader tmp;
        
        tmp = Echo.UdprLibHeaderHelper.extract(value);
        if (tmp == null)
            System.err.println("Extraccin invlida");
		
        // Encode
        try {
            byte [] buffer = this.m_codec.encode(value);
            pack.data = buffer;
            this.m_fooMIOP_ref.push2(pack);
        } catch (InvalidTypeForEncoding e) {
            e.printStackTrace();
        } 	
    }

    public void push3(Any value) {
        Echo.ExampleEvent exampleEvt;

        exampleEvt = Echo.ExampleEventHelper.extract(value);

        if (exampleEvt == null)
            System.err.println("Extraccin invlida");

    }

    public void push_radar(Any value) {
        // Encode
        try {
            byte [] buffer = this.m_codec.encode(value);
            this.m_fooMIOP_ref.push_radar(buffer);
        } catch (InvalidTypeForEncoding e) {
            e.printStackTrace();
        } 		
    }

    public void push_invocation(Any value) {

    }

    public void op() throws FooException {
        throw new FooException();
    }

    public boolean op2(int value) {
        this.count++;
        if (this.count%10 == 0)
            System.err.println("[FooImpl op2] called " + this.count + " times");
        return true;
    }

    public String echo(Any value) {
        String cadena;
        org.omg.CORBA.TypeCode type = value.type();
        org.omg.CORBA.TCKind tc_kind = type.kind();
		
        if (tc_kind == org.omg.CORBA.TCKind.tk_string)
            cadena = value.extract_string();
        else
            // No ha llegado el Any
            return "echo error";
        this.count++;
        if (this.count%10 == 0)
            System.err.println("[FooImpl echo] called " + this.count + " times");
        return cadena;
    }

    public void shutdown() {
        System.err.println("[FooImpl shutdown] called");
        this.m_fooMIOP_ref.shutdown();
    }

}
