/*
* MORFEO Project
* http://www.morfeo-project.org
*
* Component: TIDorbJTest
* Programming Language: Java
*
* File: $Source: Server2.java $
* Version: $Revision: 1.0 $
* Date: $Date: 22-sep-2006 $
* Last modified by: $Author: irenka.redondo $
*
* (C) Copyright 2004 Telefnica Investigacin y Desarrollo
*     S.A.Unipersonal (Telefnica I+D)
*
* Info about members and contributors of the MORFEO project
* is available at:
*
*   http://www.morfeo-project.org/TIDorbJ/CREDITS
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*
* If you want to use this software an plan to distribute a
* proprietary application in any way, and you are not licensing and
* distributing your source code under GPL, you probably need to
* purchase a commercial license of the product.  More info about
* licensing options is available at:
*
*   http://www.morfeo-project.org/TIDorbJ/Licensing
*/

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import org.omg.CORBA.ORB;
import org.omg.CORBA.Object;
import org.omg.CORBA.SystemException;
import org.omg.CORBA.UserException;
import org.omg.IOP.Codec;
import org.omg.IOP.CodecFactory;
import org.omg.IOP.CodecFactoryHelper;
import org.omg.IOP.ENCODING_CDR_ENCAPS;
import org.omg.IOP.Encoding;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAHelper;
import org.omg.PortableServer.POAManager;

import Test.Tester3;
import Test.Tester3Helper;

public class Server2 {
	
    public static void main(String[] args) {
        // Identificador del servidor
        String server_name = "Server2";
			
        try {
            // Crea e inicializa el orb
            /*
            Properties props = new Properties();
            props.setProperty("org.omg.CORBA.ORBClass", 
                              "es.tid.TIDorbj.core.TIDORB");
            props.setProperty("org.omg.CORBA.ORBSingletonClass", 
                              "es.tid.TIDorbj.core.SingletonORB");

            ORB orb = ORB.init(args, props);
            */
            ORB orb = ORB.init(args, System.getProperties());

            // Obtiene referencias al rootPOA y su POAManager
            Object obj = orb.resolve_initial_references("RootPOA");
            POA rootpoa = POAHelper.narrow(obj);
            POAManager rootpoamgr = rootpoa.the_POAManager();
			
            // Obtiene codec factory
            obj = orb.resolve_initial_references("CodecFactory");
            CodecFactory codec_factory = CodecFactoryHelper.narrow(obj);
			
            // Crea codec
            Encoding encoding = new Encoding();
            encoding.format = ENCODING_CDR_ENCAPS.value;
            encoding.major_version = 1;
            encoding.minor_version = 2;
            Codec codec = codec_factory.create_codec(encoding);
			
            // Crea un servant de la interfaz Test.Tester3
            Tester3Impl servant = new Tester3Impl(server_name, orb, rootpoa, codec);
   	    	
            // Activa el servant en el RootPOA
            byte[] oid = rootpoa.activate_object(servant);
            Object obj2 = rootpoa.id_to_reference(oid);
            Tester3 tester3_ref = Tester3Helper.narrow(obj2);
   			
            // Vuelca en fichero la referencia como cadena de caracteres
            String str_ior = orb.object_to_string(tester3_ref);
            Server.writeIOR2File("Tester3.ior", orb, tester3_ref);
   			
            // Activa el RootPOAManager
            rootpoamgr.activate();
   			
            // Acepta peticiones
            System.out.println("[" + server_name + "] Running...");

            orb.run();
            orb.destroy();
			
            System.exit(0);
			
        } catch (SystemException e) {
            System.err.println("Main: org.omg.CORBA.SystemException " + 
                               e.getMessage());
            e.printStackTrace();
            System.exit(1);
        } catch (UserException e) {
            System.err.println("Main: org.omg.CORBA.UserException " + 
                               e.getMessage());
            e.printStackTrace();
            System.exit(1);
        } catch (IOException e) {
            System.err.println("Main: java.io.IOException " + 
                               e.getMessage());
            e.printStackTrace();
            System.exit(1);
        } catch (Exception e) {
            System.err.println("Main: Unexpected exception " + e.getMessage());
            e.printStackTrace();
            System.exit(1);
        }
    }

}
