/*
 * MORFEO Project
 * http://www.morfeo-project.org
 *
 * Component: TIDorbJTest
 * Programming Language: Java
 *
 * File: $Source: SurveillanceManagerAsterix30Impl.java $
 * Version: $Revision: 1.0 $
 * Date: $Date: 17-ago-2006 $
 * Last modified by: $Author: irenka.redondo $
 *
 * (C) Copyright 2004 Telefnica Investigacin y Desarrollo
 *     S.A.Unipersonal (Telefnica I+D)
 *
 * Info about members and contributors of the MORFEO project
 * is available at:
 *
 *   http://www.morfeo-project.org/TIDorbJ/CREDITS
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * If you want to use this software an plan to distribute a
 * proprietary application in any way, and you are not licensing and
 * distributing your source code under GPL, you probably need to
 * purchase a commercial license of the product.  More info about
 * licensing options is available at:
 *
 *   http://www.morfeo-project.org/TIDorbJ/Licensing
 */

import Marshalling.CalculatedTrackAltitude;
import Marshalling.CalculationMode;
import Marshalling.Hemisphere;
import Marshalling.HorizontalTendency;
import Marshalling.LastMesuredModeC;
import Marshalling.LatLong2DPosition;
import Marshalling.LatLongDirection;
import Marshalling.Latitude;
import Marshalling.Longitude;
import Marshalling.MesuredPosition;
import Marshalling.PlotAge;
import Marshalling.RadarTrack;
import Marshalling.RadarTracksListHolder;
import Marshalling.RadarUpdate;
import Marshalling.SlantRangeCode;
import Marshalling.SpecialCode;
import Marshalling.SpeedTendency;
import Marshalling.StateVector;
import Marshalling.SurveillanceManagerAsterix30POA;
import Marshalling.TargetType;
import Marshalling.Tendencies;
import Marshalling.TrackStatus;
import Marshalling.TrackType;
import Marshalling.TrackVelocity;
import Marshalling.VerticalTendency;
import Marshalling.eventNum;

public class SurveillanceManagerAsterix30Impl 
    extends SurveillanceManagerAsterix30POA {
    
    public void TracksIN(RadarTrack[] trackEvent) {
        // TODO Auto-generated method stub
        
    } 

    public void TracksOUT(RadarTracksListHolder trackEvent) {
        trackEvent.value = new RadarTrack[eventNum.value];
        
        for (int j=0; j<trackEvent.value.length; j++) {
            trackEvent.value [j] = new RadarTrack();
            trackEvent.value[j].state_vector = new StateVector();
            trackEvent.value[j].state_vector.calculated_track_altitude = new CalculatedTrackAltitude();
            trackEvent.value[j].state_vector.calculated_track_altitude.calculation_mode = CalculationMode.ASSUMED_HEIGHT;
            trackEvent.value[j].state_vector.last_mesured_mode_C = new LastMesuredModeC();
            trackEvent.value[j].state_vector.latlong_position = new LatLong2DPosition();
            trackEvent.value[j].state_vector.latlong_position.latit = new Latitude();
            trackEvent.value[j].state_vector.latlong_position.latit.lat_hemis = Hemisphere.NORTH;
            trackEvent.value[j].state_vector.latlong_position.longit = new Longitude();
            trackEvent.value[j].state_vector.latlong_position.longit.long_dir = LatLongDirection.EAST;
            trackEvent.value[j].state_vector.Mesured_Position = new MesuredPosition();
            trackEvent.value[j].state_vector.Plot_Age = new PlotAge();
            trackEvent.value[j].state_vector.track_status = new TrackStatus();
            trackEvent.value[j].state_vector.track_status.radar_update = RadarUpdate.PR_MONOTRACK;
            trackEvent.value[j].state_vector.track_status.slant_range_code = SlantRangeCode.SLR_NOT_CORRECTED;
            trackEvent.value[j].state_vector.track_status.special_code = SpecialCode.DEFAULT_SPECIAL_CODE;
            trackEvent.value[j].state_vector.track_status.target_type = TargetType.LIVE_TARGET;
            trackEvent.value[j].state_vector.track_status.track_type = TrackType.CONFIRMED_TRACK;
            trackEvent.value[j].state_vector.track_tendencies = new Tendencies();
            trackEvent.value[j].state_vector.track_tendencies.horizontal = HorizontalTendency.LEFT;
            trackEvent.value[j].state_vector.track_tendencies.speed = SpeedTendency.ACCELERATE;
            trackEvent.value[j].state_vector.track_tendencies.vertical = VerticalTendency.CLIMB;
            trackEvent.value[j].state_vector.track_velocity = new TrackVelocity();
        }
    }

    public void TracksINOUT(RadarTracksListHolder trackEvent) {
        // TODO Auto-generated method stub

    }

    public RadarTrack[] TracksRET() {
        RadarTrack [] trackEvent = new RadarTrack [eventNum.value];
        for (int j=0; j<trackEvent.length; j++) {
            trackEvent[j] = new RadarTrack();
            trackEvent[j].state_vector = new StateVector();
            trackEvent[j].state_vector.calculated_track_altitude = new CalculatedTrackAltitude();
            trackEvent[j].state_vector.calculated_track_altitude.calculation_mode = CalculationMode.ASSUMED_HEIGHT;
            trackEvent[j].state_vector.last_mesured_mode_C = new LastMesuredModeC();
            trackEvent[j].state_vector.latlong_position = new LatLong2DPosition();
            trackEvent[j].state_vector.latlong_position.latit = new Latitude();
            trackEvent[j].state_vector.latlong_position.latit.lat_hemis = Hemisphere.NORTH;
            trackEvent[j].state_vector.latlong_position.longit = new Longitude();
            trackEvent[j].state_vector.latlong_position.longit.long_dir = LatLongDirection.EAST;
            trackEvent[j].state_vector.Mesured_Position = new MesuredPosition();
            trackEvent[j].state_vector.Plot_Age = new PlotAge();
            trackEvent[j].state_vector.track_status = new TrackStatus();
            trackEvent[j].state_vector.track_status.radar_update = RadarUpdate.PR_MONOTRACK;
            trackEvent[j].state_vector.track_status.slant_range_code = SlantRangeCode.SLR_NOT_CORRECTED;
            trackEvent[j].state_vector.track_status.special_code = SpecialCode.DEFAULT_SPECIAL_CODE;
            trackEvent[j].state_vector.track_status.target_type = TargetType.LIVE_TARGET;
            trackEvent[j].state_vector.track_status.track_type = TrackType.CONFIRMED_TRACK;
            trackEvent[j].state_vector.track_tendencies = new Tendencies();
            trackEvent[j].state_vector.track_tendencies.horizontal = HorizontalTendency.LEFT;
            trackEvent[j].state_vector.track_tendencies.speed = SpeedTendency.ACCELERATE;
            trackEvent[j].state_vector.track_tendencies.vertical = VerticalTendency.CLIMB;
            trackEvent[j].state_vector.track_velocity = new TrackVelocity();
        }
        return trackEvent;
    }


//     public Boolean synchronize_client()
//     { return (m_clients == m_clients_to_wait); }
}

