/*
* MORFEO Project
* http://www.morfeo-project.org
*
* Component: TIDorbJTest
* Programming Language: Java
*
* File: $Source: Tester1Impl.java $
* Version: $Revision: 1.0 $
* Date: $Date: 22-sep-2006 $
* Last modified by: $Author: irenka.redondo $
*
* (C) Copyright 2004 Telefnica Investigacin y Desarrollo
*     S.A.Unipersonal (Telefnica I+D)
*
* Info about members and contributors of the MORFEO project
* is available at:
*
*   http://www.morfeo-project.org/TIDorbJ/CREDITS
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*
* If you want to use this software an plan to distribute a
* proprietary application in any way, and you are not licensing and
* distributing your source code under GPL, you probably need to
* purchase a commercial license of the product.  More info about
* licensing options is available at:
*
*   http://www.morfeo-project.org/TIDorbJ/Licensing
*/

import java.util.Date;

import org.omg.CORBA.Any;
import org.omg.CORBA.ORB;
import org.omg.CORBA.SystemException;
import org.omg.IOP.Codec;
import org.omg.PortableServer.POA;

import Test.ComplexData;
import Test.ComplexDataHelper;
import Test.Tester1;
import Test.Tester1POA;
import Test.Tester2;
import Test.Tester3;

public class Tester1Impl extends Tester1POA {
	
    private ORB m_orb;
    private POA m_poa;
    private Codec m_codec;
    private Tester1 m_tester1_ref;
    private Tester2 m_tester2_ref;
    private Tester3 m_tester3_ref;

    // Number of events waited to be send per client
    private int m_events;  

    // Number of clients connected with servant at the moment
    private int m_clients; 

    // Total number of clients to wait to be connected with servant    
    private int m_clients_to_wait; 

    public int push1_phase1_count;
    public int push2_phase1_count;
    public int push3_phase1_count;
    public int push1_phase2_count;
    public int push2_phase2_count;
    public int push3_phase2_count;
    public int push1_phase3_count;
    public int push2_phase3_count;
    public int push3_phase3_count;
    
    public int push1_phase1_count_ended;
    public int push2_phase1_count_ended;
    public int push3_phase1_count_ended;
    public int push1_phase2_count_ended;
    public int push2_phase2_count_ended;
    public int push3_phase2_count_ended;
    public int push1_phase3_count_ended;
    public int push2_phase3_count_ended;
    public int push3_phase3_count_ended;


    public Tester1Impl (String server_name, 
                        ORB orb, POA poa, 
                        Codec codec, 
                        int number_clients_to_wait,
                        Tester2 tester2_ref, 
                        Tester3 tester3_ref) 
    {
        m_orb = orb;
        m_poa = poa;
        m_codec = codec;
        
        m_tester1_ref = null;
        m_tester2_ref = tester2_ref;
        m_tester3_ref = tester3_ref;
        
        m_events = 0;
        m_clients = 0;
        m_clients_to_wait = number_clients_to_wait;

        push1_phase1_count = 0;
        push2_phase1_count = 0;
        push3_phase1_count = 0;
        push1_phase2_count = 0;
        push2_phase2_count = 0;
        push3_phase2_count = 0;
        push1_phase3_count = 0;
        push2_phase3_count = 0;
        push3_phase3_count = 0;
        push1_phase1_count_ended = 0;
        push2_phase1_count_ended = 0;
        push3_phase1_count_ended = 0;
        push1_phase2_count_ended = 0;
        push2_phase2_count_ended = 0;
        push3_phase2_count_ended = 0;
        push1_phase3_count_ended = 0;
        push2_phase3_count_ended = 0;
        push3_phase3_count_ended = 0;
    }
    

    public int get_count_push1_phase1() 
    { return push1_phase1_count; }
    public int get_count_push2_phase1() 
    { return push2_phase1_count; }
    public int get_count_push3_phase1() 
    { return push3_phase1_count; }
    public int get_count_push1_phase2() 
    { return push1_phase2_count; }
    public int get_count_push2_phase2() 
    { return push2_phase2_count; }
    public int get_count_push3_phase2() 
    { return push3_phase2_count; }
    public int get_count_push1_phase3() 
    { return push1_phase3_count; }
    public int get_count_push2_phase3() 
    { return push2_phase3_count; }
    public int get_count_push3_phase3() 
    { return push3_phase3_count; }

    public int get_count_push1_phase1_ended() 
    { return push1_phase1_count_ended; }
    public int get_count_push2_phase1_ended() 
    { return push2_phase1_count_ended; }
    public int get_count_push3_phase1_ended() 
    { return push3_phase1_count_ended; }
    public int get_count_push1_phase2_ended() 
    { return push1_phase2_count_ended; }
    public int get_count_push2_phase2_ended() 
    { return push2_phase2_count_ended; }
    public int get_count_push3_phase2_ended() 
    { return push3_phase2_count_ended; }
    public int get_count_push1_phase3_ended() 
    { return push1_phase3_count_ended; }
    public int get_count_push2_phase3_ended() 
    { return push2_phase3_count_ended; }
    public int get_count_push3_phase3_ended() 
    { return push3_phase3_count_ended; }


    public int get_clients() 
    { return m_clients; }
    
    public void set_local_reference (Tester1 tester_ref) 
    {
        m_tester1_ref = tester_ref;
    }
	
    public void register_client(int id, int events) 
    {
        m_events = m_events + events;
        m_clients++;
    }
    public boolean synchronize_client()
    { return (m_clients == m_clients_to_wait); }



    // 
    // Phase 1
    //
	
    public void push1_phase1(Any value) {
        push1_phase1_count++;

        // Se extrae el any
        try {
            String cadena = value.extract_string();
        } catch (SystemException e) {
            ComplexData cdata = ComplexDataHelper.extract(value);
        }

        push1_phase1_count_ended++;
    }

    public Any push2_phase1(Any value) {
        push2_phase1_count++;
        Any result = m_orb.create_any();
		
        // Se extrae el any
        String cadena, cadena2 = null;
		
        try {
            cadena = value.extract_string();
            result.insert_string(cadena);
        } catch (SystemException e) {
            ComplexData cdata;
            try {
                cdata = ComplexDataHelper.extract(value);
                result.insert_string(cdata.name);
            } catch (SystemException e2) {
                result.insert_string(cadena2);
            }
        }
        push2_phase1_count_ended++;
        return result;
    }

    public void push3_phase1(Any value) {
        push3_phase1_count++;
        // Extraer el any
        // ...
		
        push3_phase1_count_ended++;
    }

    // 
    // Phase 2
    //
	
    public int push1_phase2(Any value) {
        push1_phase2_count++;
        Date t1, t2;
        int total=0, tt;

        if (m_tester2_ref != null) {
            t1 = new Date();
            m_tester2_ref.push1_phase2(value);
            t2 = new Date();
            tt = (int)Client.timeDiff(t1, t2);
            total = total + tt;
        } else
            System.err.println("referencia nula");
		
        push1_phase2_count_ended++;
        return total;
    }

    public int push2_phase2(Any value) {
        push2_phase2_count++;
        Date t1, t2;
        int total=0, tt;

        if (m_tester2_ref != null) {
            t1 = new Date();
            Any result = m_tester2_ref.push2_phase2(value);
            t2 = new Date();
            tt = (int)Client.timeDiff(t1, t2);
            total = total + tt;
        } 
        push2_phase2_count_ended++;
        return total;
    }

    public int push3_phase2(Any value) {
        push3_phase2_count++;
        Date t1, t2;
        int total=0, tt;

        if (m_tester2_ref != null) {
            t1 = new Date();
            m_tester2_ref.push3_phase2(value);
            t2 = new Date();
            tt = (int)Client.timeDiff(t1, t2);
            total = total + tt;
        } 
        push3_phase2_count_ended++;
        return total;
    }

    // 
    // Phase 3
    //
	
    public int push1_phase3(Any value) {
        push1_phase3_count++;

        Date t1, t2;
        int total=0, tt;

        if (m_tester3_ref != null) {
            t1 = new Date();
            m_tester3_ref.push1_phase3(value);
            t2 = new Date();
            tt = (int)Client.timeDiff(t1, t2);
            total = total + tt;
        } 
        push1_phase3_count_ended++;
        return total;
    }

    public int push2_phase3(Any value) {
        push2_phase3_count++;
        Date t1, t2;
        int total=0, tt;

        if (m_tester3_ref != null) {
            t1 = new Date();
            Any result = m_tester3_ref.push2_phase3(value);
            t2 = new Date();
            tt = (int)Client.timeDiff(t1, t2);
            total = total + tt;
        } 
        push2_phase3_count_ended++;
        return total;
    }

    public int push3_phase3(Any value) {
        push3_phase3_count++;
        Date t1, t2;
        int total=0, tt;

        if (m_tester3_ref != null) {
            t1 = new Date();
            m_tester3_ref.push3_phase3(value);
            t2 = new Date();
            tt = (int)Client.timeDiff(t1, t2);
            total = total + tt;
        } 
        push3_phase3_count_ended++;
        return total;
    }

}
