/*
* MORFEO Project
* http://www.morfeo-project.org
*
* Component: TIDorbJTest
* Programming Language: Java
*
* File: $Source: Tester3Impl.java $
* Version: $Revision: 1.0 $
* Date: $Date: 22-sep-2006 $
* Last modified by: $Author: irenka.redondo $
*
* (C) Copyright 2004 Telefnica Investigacin y Desarrollo
*     S.A.Unipersonal (Telefnica I+D)
*
* Info about members and contributors of the MORFEO project
* is available at:
*
*   http://www.morfeo-project.org/TIDorbJ/CREDITS
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*
* If you want to use this software an plan to distribute a
* proprietary application in any way, and you are not licensing and
* distributing your source code under GPL, you probably need to
* purchase a commercial license of the product.  More info about
* licensing options is available at:
*
*   http://www.morfeo-project.org/TIDorbJ/Licensing
*/

import org.omg.CORBA.Any;
import org.omg.CORBA.ORB;
import org.omg.CORBA.SystemException;
import org.omg.IOP.Codec;
import org.omg.PortableServer.POA;

import Test.ComplexData;
import Test.ComplexDataHelper;
import Test.Tester3POA;

public class Tester3Impl extends Tester3POA {

    private ORB m_orb;
    private POA m_poa;
    private Codec m_codec;

    private int m_events;  // Numero total de eventos esperados
	
    public int push1_phase3_count;
    public int push2_phase3_count;
    public int push3_phase3_count;
    
    public int push1_phase3_count_ended;
    public int push2_phase3_count_ended;
    public int push3_phase3_count_ended;
    

    public Tester3Impl (String server_name, 
                        ORB orb, 
                        POA poa, 
                        Codec codec) 
    {
        m_orb = orb;
        m_poa = poa;
        m_codec = codec;
		
        m_events = 0;
        
        push1_phase3_count = 0;
        push2_phase3_count = 0;
        push3_phase3_count = 0;

        push1_phase3_count_ended = 0;
        push2_phase3_count_ended = 0;
        push3_phase3_count_ended = 0;
        
    }

    public void register_server(int events) {
        // actualizar el numero de eventos
        // ...
    }

    public int get_count_push1_phase3() 
    { return push1_phase3_count; }
    public int get_count_push2_phase3() 
    { return push2_phase3_count; }
    public int get_count_push3_phase3() 
    { return push3_phase3_count; }
    
    public int get_count_push1_phase3_ended() 
    { return push1_phase3_count; }
    public int get_count_push2_phase3_ended() 
    { return push2_phase3_count; }
    public int get_count_push3_phase3_ended() 
    { return push3_phase3_count; }



    public void push1_phase3(Any value) {
        push1_phase3_count++;
        // Se extrae el any
        try {
            String cadena = value.extract_string();
        } catch (SystemException e) {
            ComplexData cdata = ComplexDataHelper.extract(value);
        }
        push1_phase3_count_ended++;
    }

    public Any push2_phase3(Any value) {
        push2_phase3_count++;
        Any result = m_orb.create_any();
		
        // Se extrae el any
        String cadena, cadena2 = null;
		
        try {
            cadena = value.extract_string();
            result.insert_string(cadena);
        } catch (SystemException e) {
            ComplexData cdata;
            try {
                cdata = ComplexDataHelper.extract(value);
                result.insert_string(cdata.name);
            } catch (SystemException e2) {
                result.insert_string(cadena2);
            }
        }
        push2_phase3_count_ended++;
        return result;
    }

    public void push3_phase3(Any value) {
        push3_phase3_count++;
        // Extraer el any
        // Componer el resultado
        // ...
        push3_phase3_count_ended++;
    }

}
