#!/bin/sh
#
# MORFEO Project
# http://www.morfeo-project.org
#
# Component: TIDorbJ
# Programming Language: Java
#
# File: $Source: /cvsroot/tidorbj/TIDorbJTest/performance/atc/startClients_TIDorbJ.sh,v $
# Version: $Revision: 1.0 $
# Date: $Date: 2006/08/21 12:09:28 $
# Last modified by: $Author: iredondo $
#
# (C) Copyright 2004 Telefnica Investigacin y Desarrollo
#     S.A.Unipersonal (Telefnica I+D)
#
# Info about members and contributors of the MORFEO project
# is available at:
#
#   http://www.morfeo-project.org/TIDIdlc/CREDITS
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# If you want to use this software an plan to distribute a
# proprietary application in any way, and you are not licensing and
# distributing your source code under GPL, you probably need to
# purchase a commercial license of the product.  More info about
# licensing options is available at:
#
#   http://www.morfeo-project.org/TIDIdlc/Licensing
#

set +u

if [ -z "$JAVA_HOME" ]; then
    echo "Environment variable JAVA_HOME must be set"
    exit 1
fi

if [ -z "$TIDORBJ_HOME" ]; then
    echo "Environment variable TIDORBJ_HOME must be set"
    exit 1	
fi

if [ -z "$1" ]; then
    echo "Usage: startConTested.sh num_clients"
    exit 1	
fi

nevents=400;
nclients=$1;

export JVM=$JAVA_HOME/bin/java

#
# Start server2
#
$JVM -classpath .:$CONTEST_HOME/Lib/ConTest.jar:$CONTEST_HOME/Lib/racedetector.jar:$CONTEST_HOME/Lib/deadlockcauser.jar:$TIDORBJ_HOME/lib/tidorbj_contest.jar \
    -Dorg.omg.CORBA.ORBClass=es.tid.TIDorbj.core.TIDORB \
    -Dorg.omg.CORBA.ORBSingletonClass=es.tid.TIDorbj.core.SingletonORB \
    Server2 \
    es.tid.TIDorbj.trace.level 4 \
    es.tid.TIDorbj.trace.file server2.log \
    es.tid.TIDorbj.max_blocked_time 150000 \
    es.tid.TIDorbj.poa.max_queued_requests 1000 \
    es.tid.TIDorbj.typecode_cache_size 400 \
    es.tid.TIDorbj.poa.min_threads 20 \
    es.tid.TIDorbj.poa.max_threads 20 &
server_pid=$!
sleep 10

#
# Start server
#
$JVM -classpath .:$CONTEST_HOME/Lib/ConTest.jar:$CONTEST_HOME/Lib/racedetector.jar:$CONTEST_HOME/Lib/deadlockcauser.jar:$TIDORBJ_HOME/lib/tidorbj_contest.jar \
 -Dorg.omg.CORBA.ORBClass=es.tid.TIDorbj.core.TIDORB \
    -Dorg.omg.CORBA.ORBSingletonClass=es.tid.TIDorbj.core.SingletonORB \
    Server \
    es.tid.TIDorbj.trace.level 4 \
    es.tid.TIDorbj.trace.file server.log \
    es.tid.TIDorbj.max_blocked_time 150000 \
    es.tid.TIDorbj.poa.max_queued_requests 1000 \
    es.tid.TIDorbj.typecode_cache_size 400 \
    es.tid.TIDorbj.poa.min_threads 20 \
    es.tid.TIDorbj.poa.max_threads 20 &
server2_pid=$!
sleep 10


#
# Start nclients with nevents in phase
#
phase=1;
while [[ $phase -le 1 ]];
  do
  
  client_pids=() 

  #
  # Start all clients 
  #
  for ((i=1; i<=$nclients; i++))
    do
    $JVM -classpath .:$CONTEST_HOME/Lib/ConTest.jar:$CONTEST_HOME/Lib/racedetector.jar:$CONTEST_HOME/Lib/deadlockcauser.jar:$TIDORBJ_HOME/lib/tidorbj_contest.jar \
        -Dorg.omg.CORBA.ORBClass=es.tid.TIDorbj.core.TIDORB \
        -Dorg.omg.CORBA.ORBSingletonClass=es.tid.TIDorbj.core.SingletonORB \
        Client $i $nevents $phase  \
        es.tid.TIDorbj.max_blocked_time 300000 \
        es.tid.TIDorbj.typecode_cache_size 400 > client_$1_result_TIDorbJ_$phase.txt &
    last_client_pid=$!
    client_pids[$i]=$last_client_pid
  done
  
  #
  # Wait to all clients are ended
  #
  already_client_exec=0
  i=0
  i=`expr $i + 1`
  while [ $i -le $nclients ]; do
      client_exec=`ps -p ${client_pids[$i]} | wc -l`
      if [ $client_exec -eq 2 ]; then
          already_client_exec=1
      fi
      i=`expr $i + 1`
  done
  while [ $already_client_exec -eq 1 ]; do
      sleep 1
      already_client_exec=0
      i=0
      i=`expr $i + 1`
      while [ $i -le $nclients ]; do
          client_exec=`ps -p ${client_pids[$i]} | wc -l`
          if [ $client_exec -eq 2 ]; then
              already_client_exec=1
          fi
          i=`expr $i + 1`
      done
  done


  phase=`expr $phase + 1`;
done

export JVM= 



sleep 10
echo "Press any key to kill servers"
read n

kill $server_pid
kill $server2_pid
